import wblut.processing.*;
import wblut.hemesh.*;
import wblut.geom.*;
import wblut.core.*;
import wblut.math.*;
import java.util.List;

WB_Render3D render;
WB_GeometryFactory gf;
WB_Polygon boundary;
WB_Danzer danzerA;
List<WB_Polygon> polys;

void setup() {
  size(800, 800, P3D);
  smooth(8);
  strokeWeight(1.4);
  noFill();
  render=new WB_Render3D(this);
  gf=WB_GeometryFactory.instance();
  createBoundaryPolygon();
  println(WB_Version.version());
  println(WB_Disclaimer.disclaimer());
  danzerA=new WB_Danzer(2400, WB_Danzer.Type.A,new WB_Point(0,0,0));
  danzerA.inflate(4);
 polys=new ArrayList<WB_Polygon>();
 for(WB_Polygon poly:danzerA.getTiles()){
  polys.addAll(gf.intersectPolygons(boundary,poly));
 }
  
  
}

void draw() {
  background(50);
  directionalLight(255, 255, 255, 1, 1, -1);
  directionalLight(127, 127, 127, -1, -1, 1);
  translate(width/2, height/2, 0);
  rotateY(map(mouseX,0,width,-PI,PI));
  rotateX(map(mouseY,0,height,-PI,PI));
  strokeWeight(1);
  stroke(0);
  for (WB_Polygon poly : polys) {
    render.drawPolygon(poly);
  } 
  strokeWeight(2);
  stroke(255,0,0);
  render.drawPolygonEdges(boundary);
}

void createBoundaryPolygon(){
  ArrayList<WB_Point> shell;
  ArrayList<WB_Point>[] holes;
    shell= new ArrayList<WB_Point>();
  for (int i=0; i<20; i++) {
    shell.add(gf.createPointFromPolar(100+100*(i%2+1), TWO_PI/20.0*i));
  }
  //holes and points cannot overlap
  holes= new ArrayList[2];
  ArrayList<WB_Point> hole=new ArrayList<WB_Point>();
  for (int i=0; i<10; i++) {
    hole.add(gf.createPointFromPolar(40*(i%2+1), -TWO_PI/10.*i).addSelf(-80, 0, 0));
  } 
  holes[0]=hole;
  hole=new ArrayList<WB_Point>();
  for (int i=0; i<10; i++) {
    hole.add(gf.createPointFromPolar(40*(i%2+1), PI-TWO_PI/10.*i).addSelf(80, 0, 0));
  } 
  holes[1]=hole;
  boundary=gf.createPolygonWithHoles(shell,holes);
  
}

void mousePressed(){
  java.util.Date dNow = new java.util.Date( );
  java.text.SimpleDateFormat ft = new java.text.SimpleDateFormat ("yyyy_MM_dd_hhmmss_S");
  saveFrame("d:/screenshots/"+this.getClass().getName()+"/"+this.getClass().getName()+"_"+ft.format(dNow)+  ".png"); 
}