import wblut.processing.*;
import wblut.hemesh.*;
import wblut.geom.*;
import wblut.math.*;
import java.util.List;

WB_GeometryFactory gf=WB_GeometryFactory.instance();
WB_Render2D render;
ArrayList<WB_Point> shell;
ArrayList<WB_Point>[] holes;
WB_Polygon polygon;
List<WB_Polygon> buffer;
void setup() {
  size(800, 800, OPENGL);
  smooth(8);
  render=new WB_Render2D(this);
  shell= new ArrayList<WB_Point>();
  for (int i=0; i<20; i++) {
    shell.add(gf.createPointFromPolar(50+75*(i%2+1), TWO_PI/20.0*i));
  }
  holes= new ArrayList[2];
  ArrayList<WB_Point> hole=new ArrayList<WB_Point>();
  for (int i=0; i<10; i++) {
    hole.add(gf.createPointFromPolar(20*(i%2+1), -TWO_PI/10.*i).addSelf(-50, 0, 0));
  } 
  holes[0]=hole;
  hole=new ArrayList<WB_Point>();
  for (int i=0; i<10; i++) {
    hole.add(gf.createPointFromPolar(20*(i%2+1), PI-TWO_PI/10.*i).addSelf(50, 0, 0));
  } 
  holes[1]=hole;
  polygon=gf.createPolygonWithHoles(shell, holes);
  buffer=gf.buffer(polygon, 10);
  for (int i=1; i<6; i++) {
    buffer.addAll(gf.buffer(polygon, -10*i));
  }
  for (int i=2; i<16; i++) {
    buffer.addAll(gf.buffer(polygon, 10*i));
  }
  background(255);
}

void draw() {
  background(255);
  translate(width/2, height/2);
  scale(1, -1);
  fill(255, 0, 0);
  noStroke();
  render.drawPolygon(polygon);
  noFill();
  stroke(0);
  render.drawPolygonEdges(polygon);
  for (WB_Polygon poly : buffer) {
    render.drawPolygonEdges(poly);
  }
}

